Qt 5.6 | Qt 3D | C++ Classes | QDiffuseMapMaterial

Qt 5.6.3 Reference Documentation

# QDiffuseMapMaterial Class

(Qt3DRender::QDiffuseMapMaterial)

The QDiffuseMapMaterial provides a default implementation of the phong lighting effect where the diffuse light component is read from a texture map. More...

Header: | #include <QDiffuseMapMaterial>
qmake: | QT += 3drender
Since: | Qt 5.5
Inherits: | QMaterial

- List of all members, including inherited members

## Properties

ambient : QColor diffuse : Qt3DRender::QAbstractTextureProvider * shininess : float | specular : QColor textureScale : float

- 1 property inherited from Qt3DRender::QMaterial
- 1 property inherited from Qt3DCore::QComponent
- 2 properties inherited from Qt3DCore::QNode

## Public Functions

| QDiffuseMapMaterial(Qt3DCore::QNode *parent = Q_NULLPTR)
| ~QDiffuseMapMaterial()
QColor | ambient() const
QAbstractTextureProvider * | diffuse() const
float | shininess() const
QColor | specular() const
float | textureScale() const

- 6 public functions inherited from Qt3DRender::QMaterial
- 2 public functions inherited from Qt3DCore::QComponent
- 6 public functions inherited from Qt3DCore::QNode

## Public Slots

void | setAmbient(const QColor &color)
void | setDiffuse(QAbstractTextureProvider *diffuse)
void | setShininess(float shininess)
void | setSpecular(const QColor &specular)
void | setTextureScale(float textureScale)

- 1 public slot inherited from Qt3DRender::QMaterial
- 1 public slot inherited from Qt3DCore::QComponent
- 2 public slots inherited from Qt3DCore::QNode

## Signals

void | ambientChanged(const QColor &ambient)
void | diffuseChanged(QAbstractTextureProvider *diffuse)
void | shininessChanged(float shininess)
void | specularChanged(const QColor &specular)
void | textureScaleChanged(float textureScale)

- 1 signal inherited from Qt3DRender::QMaterial
- 2 signals inherited from Qt3DCore::QComponent
- 2 signals inherited from Qt3DCore::QNode

### Additional Inherited Members

- 1 protected function inherited from Qt3DRender::QMaterial
- 1 protected function inherited from Qt3DCore::QComponent
- 3 protected functions inherited from Qt3DCore::QNode
- 1 static protected member inherited from Qt3DCore::QNode

## Detailed Description

The QDiffuseMapMaterial provides a default implementation of the phong lighting effect where the diffuse light component is read from a texture map.

The specular lighting effect is based on the combination of 3 lighting components ambient, diffuse and specular. The relative strengths of these components is controlled by means of their reflectivity coefficients which are modelled as RGB triplets:

- Ambient is the color that is emitted by an object without any other light source.
- Diffuse is the color that is emitted for rought surface reflections with the lights.
- Specular is the color emitted for shiny surface reflections with the lights.
- The shininess of a surface is controlled by a float property.

This material uses an effect with a single render pass approach and performs per fragment lighting. Techniques are provided for OpenGL 2, OpenGL 3 or above as well as OpenGL ES 2.

## Property Documentation

### ambient : QColor

Holds the current ambient color.

Access functions:

QColor | ambient() const
void | setAmbient(const QColor &color)

Notifier signal:

void | ambientChanged(const QColor &ambient)

### diffuse : Qt3DRender::QAbstractTextureProvider *

Holds the current QTexture used as the diffuse map.

By default, the diffuse texture has the following properties:

- Linear minification and magnification filters
- Linear mipmap with mipmapping enabled
- Repeat wrap mode
- Maximum anisotropy of 16.0

Access functions:

QAbstractTextureProvider * | diffuse() const
void | setDiffuse(QAbstractTextureProvider *diffuse)

Notifier signal:

void | diffuseChanged(QAbstractTextureProvider *diffuse)

### shininess : float

Holds the current shininess as a float value.

Access functions:

float | shininess() const
void | setShininess(float shininess)

Notifier signal:

void | shininessChanged(float shininess)

### specular : QColor

Holds the current specular color.

Access functions:

QColor | specular() const
void | setSpecular(const QColor &specular)

Notifier signal:

void | specularChanged(const QColor &specular)

### textureScale : float

Holds the current texture scale as a float value.

Access functions:

float | textureScale() const
void | setTextureScale(float textureScale)

Notifier signal:

void | textureScaleChanged(float textureScale)

## Member Function Documentation

### QDiffuseMapMaterial::QDiffuseMapMaterial(Qt3DCore::QNode *parent = Q_NULLPTR)

Default constructs an instance of QDiffuseMapMaterial.

### QDiffuseMapMaterial::~QDiffuseMapMaterial()

Destroys the QDiffuseMapMaterial instance.